from ..n_common.u_str import *
from ..n_common.u_out import *
import pymysql
from dataclasses import dataclass
from enum import Enum

class sql_status(Enum):
    unconnected = 1
    disconnected = 2
    connected = 3

class commitStatus(Enum):
    manual_commit = 0
    auto_commit = 1

@dataclass
class basic_db:
    host = ...
    port = ...
    user = ...
    password = ...
    charset = ...
    connection: pymysql.connections.Connection | None = ...
    def __init__(self, host: str | None = None, port: int | None = None, user: str | None = None, password: str | None = None, charset: str = 'utf8') -> None: ...
    @classmethod
    def getInstance(cls, connect: pymysql.connections.Connection | None = None, *, host: str = None, port: int = None, user: str = None, password: str = None, charset: str = 'utf8') -> basic_db | None: ...
    def connect_mysql_server(self, commit_status: commitStatus = ...): ...
    def setup(self, db_name: str, is_start_transaction: bool = False) -> None: ...
    def connect_database(self, db_name: str) -> None: ...
    def disconnect_mysql_server(self) -> None: ...
    def excuse_command(self, cmd: str) -> None: ...
    @property
    def Commit_status(self) -> commitStatus: ...
    def data_to_list(self, data: str) -> list[str]: ...
    def data_to_list2(self, data: str) -> list[str]: ...
    def set_Commit_Status(self, Commit_status) -> None: ...
    def startTransAction(self) -> None: ...
    def Commit(self) -> None: ...
    def rollback(self) -> None: ...
    def execute_sql_language(self, sql_language: str) -> tuple[tuple[any, ...], ...]: ...
    @property
    def connect_status(self) -> sql_status: ...
    def is_database_exists(self, database_name: str) -> bool: ...
    def create_database(self, database_name: str) -> None: ...
    def is_has_Table(self, tb_name: str) -> bool: ...
    def showTables(self) -> list[str]: ...
    def is_has_View(self, view_name: str) -> bool: ...
    def __del__(self) -> None: ...
